/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:
 known Problems: none
 Version:        24.10.2007
 Description:    Timer Routinen
----------------------------------------------------------------------------*/

#include "timer.h"
#include "makro.c"

volatile unsigned long time;

//----------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer
/*
void timer_init (void)
{
	wdt_reset();
	/*#if EXTCLOCK==1
		#if defined (__AVR_ATmega644__)
			//Asynchroner Modus ein, Oszillator an TOSC1 und TOSC2 aktiv
			ASSR |= (1<<AS2);
			TCCR2B = 0x05;
			while(ASSR & 0x11);
			//Capture/Compare-Interrupt aktiv
			TIMSK2 |= (1<<OCIE2A);
		#else
			//Asynchroner Modus ein, Oszillator an TOSC1 und TOSC2 aktiv
			ASSR  = (1<<AS2);
			//CTC-Modus an (Clear Timer on Compare Match)
			TCCR2 = (1<<WGM21);			
			//dieser Wert ergibt eine Sekunde Periodendauer
			OCR2  = 31;	
			//lsche Prescaler 2				
			SFIE  = (1<<PSR2);			
			//Starte Timer 2 mit Prescaler gleich 1/1024
			TCCR2 |= (1<<CS22)|(1<<CS21)|(1<<CS20); 
			while(ASSR & 0x07);
			//Capture/Compare-Interrupt aktiv
			TIMSK = (1<<OCIE2);			
		#endif
	#else*/
/*			TCCR1B |= (1<<WGM12) | (1<<CS10 | 0<<CS11 | 1<<CS12);
			TCNT1 = 0;
			OCR1A = (F_CPU / 1024) - 1;
			TIMSK1 |= (1 << OCIE1A);
	//#endif
	wdt_reset();
return;
};*/


void timer_init(void)
{	
	TCNT1=64900;
	
	CLEARBIT(TIMSK1,TOIE1); 	//Timer deaktivieren
	SETBIT(TCCR1B,CS12);		// Teiler setzen 16MhZ/1024
	SETBIT(TCCR1B,CS10);
	SETBIT(TIMSK1,TOIE1);		//Overflow Interrupt aktivieren // beim AT90CAN128	
	
}


//----------------------------------------------------------------------------
//Timer Interrupt

/*
#if EXTCLOCK==1
	//#if defined (__AVR_ATmega644__)
	#if defined (__AVR_AT90CAN128__)
		ISR (TIMER2_COMPA_vect){
	#else
		ISR (TIMER2_COMP_vect){
	#endif
#else
	ISR (TIMER1_COMPA_vect){
#endif*/

SIGNAL(SIG_OVERFLOW1)
{
	wdt_reset();
	//Sekunde um 1 erhhen
	time++;
	eth.timer = 1;
	#if USE_NTP
	ntp_timer--;
	#endif //USE_NTP
	TCNT1=63973;
	wdt_reset();
}
